#define CAMEO_CPU_DRV_DLINK_SMART_F1_LIBRARY_C
#ifdef CAMEO_CPU_DRV_DLINK_SMART_F1_LIBRARY_C

#include <cameo_single_img/cameo_single_img.h>

/* ************************************************************************** **
 *	Definitions of macros
** ************************************************************************** */
#define MAX_LINE_LENGTH_BYTES (64)
#define DEFAULT_LINE_LENGTH_BYTES (16)
#define DISP_LINE_LEN	16

/* VLAN Init Definition*/
#define VLAN_PORT_EGR_FLTR_REG1            0xbb0027c4
#define VLAN_PORT_EGR_FLTR_REG2            0xbb0027c8

#define VLAN_PORT_MEMBER_REG1              0xbb001194
#define VLAN_PORT_MEMBER_REG2              0xbb001198
#define VLAN_PORT_MEMBER_ACCESS_CTRL       0xbb001190

#define VLAN_PORT_UTAG_MEMBER_REG1         0xbb006b84
#define VLAN_PORT_UTAG_MEMBER_REG2         0xbb006b88
#define VLAN_PORT_UTAG_ACCESS_CTRL         0xbb006b80

#define VLAN_PORT_PVID_REG_BASE            0xbb0026d8
#define VLAN_PORT_PVID_VALUE_BASE          0x00010004

/* ************************************************************************** **
 *	Definitions of consts
** ************************************************************************** */
static ulong BoardIdTable_size;
static t_macro_board_info_params *pBoardIdTable;

/* ************************************************************************** **
 *	Definitions of proto type
** ************************************************************************** */
#if defined(CONFIG_RTL8380)
void Cameo_Hw_DGS1210_10_Gpio_init(void);
void Cameo_Hw_DGS1210_10_Vlan_init(uint32_t i4AddCpuPort);
void Cameo_Hw_DGS1210_10_Control_Pkt_init(uint32_t i4AddRule);
void Cameo_Hw_DGS1210_10_Vlan_HWTest(uint32_t i4HWTest_Enable);
void Cameo_Hw_DGS1210_10_if_shutdown(void);
void Cameo_Hw_DGS1210_10_board_init(void);

void Cameo_Hw_DGS1210_10P_Gpio_init(void);
void Cameo_Hw_DGS1210_10P_Vlan_init(uint32_t i4AddCpuPort);
void Cameo_Hw_DGS1210_10P_Control_Pkt_init(uint32_t i4AddRule);
void Cameo_Hw_DGS1210_10P_Vlan_HWTest(uint32_t i4HWTest_Enable);
void Cameo_Hw_DGS1210_10P_if_shutdown(void);
void Cameo_Hw_DGS1210_10P_board_init(void);

void Cameo_Hw_DGS1210_10MP_Gpio_init(void);
void Cameo_Hw_DGS1210_10MP_Vlan_init(uint32_t i4AddCpuPort);
void Cameo_Hw_DGS1210_10MP_Control_Pkt_init(uint32_t i4AddRule);
void Cameo_Hw_DGS1210_10MP_Vlan_HWTest(uint32_t i4HWTest_Enable);
void Cameo_Hw_DGS1210_10MP_if_shutdown(void);
void Cameo_Hw_DGS1210_10MP_board_init(void);

void Cameo_Hw_DGS1210_20_Gpio_init(void);
void Cameo_Hw_DGS1210_20_Vlan_init(uint32_t i4AddCpuPort);
void Cameo_Hw_DGS1210_20_Control_Pkt_init(uint32_t i4AddRule);
void Cameo_Hw_DGS1210_20_Vlan_HWTest(uint32_t i4HWTest_Enable);
void Cameo_Hw_DGS1210_20_if_shutdown(void);
void Cameo_Hw_DGS1210_20_board_init(void);

void Cameo_Hw_DGS1210_26_Gpio_init(void);
void Cameo_Hw_DGS1210_26_Vlan_init(uint32_t i4AddCpuPort);
void Cameo_Hw_DGS1210_26_Control_Pkt_init(uint32_t i4AddRule);
void Cameo_Hw_DGS1210_26_Vlan_HWTest(uint32_t i4HWTest_Enable);
void Cameo_Hw_DGS1210_26_if_shutdown(void);
void Cameo_Hw_DGS1210_26_board_init(void);

void Cameo_Hw_DGS1210_28_Gpio_init(void);
void Cameo_Hw_DGS1210_28_Vlan_init(uint32_t i4AddCpuPort);
void Cameo_Hw_DGS1210_28_Control_Pkt_init(uint32_t i4AddRule);
void Cameo_Hw_DGS1210_28_Vlan_HWTest(uint32_t i4HWTest_Enable);
void Cameo_Hw_DGS1210_28_if_shutdown(void);
void Cameo_Hw_DGS1210_28_board_init(void);

void Cameo_Hw_DGS1210_28P_Gpio_init(void);
void Cameo_Hw_DGS1210_28P_Vlan_init(uint32_t i4AddCpuPort);
void Cameo_Hw_DGS1210_28P_Control_Pkt_init(uint32_t i4AddRule);
void Cameo_Hw_DGS1210_28P_Vlan_HWTest(uint32_t i4HWTest_Enable);
void Cameo_Hw_DGS1210_28P_if_shutdown(void);
void Cameo_Hw_DGS1210_28P_board_init(void);

void Cameo_Hw_DGS1210_28MP_Gpio_init(void);
void Cameo_Hw_DGS1210_28MP_Vlan_init(uint32_t i4AddCpuPort);
void Cameo_Hw_DGS1210_28MP_Control_Pkt_init(uint32_t i4AddRule);
void Cameo_Hw_DGS1210_28MP_Vlan_HWTest(uint32_t i4HWTest_Enable);
void Cameo_Hw_DGS1210_28MP_if_shutdown(void);
void Cameo_Hw_DGS1210_28MP_board_init(void);
#elif defined(CONFIG_RTL8390)
void Cameo_Hw_DGS1210_52_Gpio_init(void);
void Cameo_Hw_DGS1210_52_Vlan_init(uint32_t i4AddCpuPort);
void Cameo_Hw_DGS1210_52_Control_Pkt_init(uint32_t i4AddRule);
void Cameo_Hw_DGS1210_52_Vlan_HWTest(uint32_t i4HWTest_Enable);
void Cameo_Hw_DGS1210_52_if_shutdown(void);
void Cameo_Hw_DGS1210_52_board_init(void);

void Cameo_Hw_DGS1210_52MP_Gpio_init(void);
void Cameo_Hw_DGS1210_52MP_Vlan_init(uint32_t i4AddCpuPort);
void Cameo_Hw_DGS1210_52MP_Control_Pkt_init(uint32_t i4AddRule);
void Cameo_Hw_DGS1210_52MP_Vlan_HWTest(uint32_t i4HWTest_Enable);
void Cameo_Hw_DGS1210_52MP_if_shutdown(void);
void Cameo_Hw_DGS1210_52MP_board_init(void);

#else
#error "#Error!! Please complete the implement for new solution!"
#endif /* #if defined(CONFIG_RTL8380) */

/* ************************************************************************** **
 *	Definitions of structs
** ************************************************************************** */
const t_macro_board_info_params cpu_drv_macro_board_info_table[] = {
#if defined(CONFIG_RTL8380)    
	{
        .pBoard_id_with_Model_Name_Type = "TEG-082WS-V2",
        .pModel_Name = "TEG-082WS",
        .pModel_Header_Name = "TEG-082WS",
        .pHW_Version = "V2.0R",
        .pModel_Show_Name = "TEG-082WS/V2.0R",
        .pModel_Name_prompt = "TEG-082WS> ",
        .Cameo_hw_if_shutdown = Cameo_Hw_DGS1210_10_if_shutdown,
        .Cameo_hw_board_init = Cameo_Hw_DGS1210_10_board_init
	},
	{
        .pBoard_id_with_Model_Name_Type = "TPE-082WS-V1",
        .pModel_Name = "TPE-082WS",
        .pModel_Header_Name = "TPE-082WS",
        .pHW_Version = "V1.0R",
        .pModel_Show_Name = "TPE-082WS/V1.0R",
        .pModel_Name_prompt = "TPE-082WS> ",
        .Cameo_hw_if_shutdown = Cameo_Hw_DGS1210_10P_if_shutdown,
        .Cameo_hw_board_init = Cameo_Hw_DGS1210_10P_board_init
	},
	{
        .pBoard_id_with_Model_Name_Type = "TPE-1020WS-V2",
        .pModel_Name = "TPE-1020WS",
        .pModel_Header_Name = "TPE-1020WS",
        .pHW_Version = "V2.0R",
        .pModel_Show_Name = "TPE-1020WS/V2.0R",
        .pModel_Name_prompt = "TPE-1020WS> ",
        .Cameo_hw_if_shutdown = Cameo_Hw_DGS1210_10MP_if_shutdown,
        .Cameo_hw_board_init = Cameo_Hw_DGS1210_10MP_board_init
	},
	{
        .pBoard_id_with_Model_Name_Type = "TEG-204WS-V1",
        .pModel_Name = "TEG-204WS",
        .pModel_Header_Name = "TEG-204WS",
        .pHW_Version = "V1.0R",
        .pModel_Show_Name = "TEG-204WS/V1.0R",
        .pModel_Name_prompt = "TEG-204WS> ",
        .Cameo_hw_if_shutdown = Cameo_Hw_DGS1210_20_if_shutdown,
        .Cameo_hw_board_init = Cameo_Hw_DGS1210_20_board_init
	},
	{
        .pBoard_id_with_Model_Name_Type = "TPE-1620WS-V2",
        .pModel_Name = "TPE-1620WS",
        .pModel_Header_Name = "TPE-1620WS",
        .pHW_Version = "V2.0R",
        .pModel_Show_Name = "TPE-1620WS/V2.0R",
        .pModel_Name_prompt = "TPE-1620WS> ",
        .Cameo_hw_if_shutdown = Cameo_Hw_DGS1210_20_if_shutdown,
        .Cameo_hw_board_init = Cameo_Hw_DGS1210_20_board_init
	},
	{
        .pBoard_id_with_Model_Name_Type = "DGS-1210-26-F1",
        .pModel_Name = "DGS-1210-26",
        .pModel_Header_Name = "DGS-1210-26",
        .pHW_Version = "F1",
        .pModel_Show_Name = "DGS-1210-26/F1",
        .pModel_Name_prompt = "DGS-1210-26> ",
        .Cameo_hw_if_shutdown = Cameo_Hw_DGS1210_26_if_shutdown,
        .Cameo_hw_board_init = Cameo_Hw_DGS1210_26_board_init
	},
	{
        .pBoard_id_with_Model_Name_Type = "TEG-284WS-V1",
        .pModel_Name = "TEG-284WS",
        .pModel_Header_Name = "TEG-284WS",
        .pHW_Version = "V1.0R",
        .pModel_Show_Name = "TEG-284WS/V1.0R",
        .pModel_Name_prompt = "TEG-284WS> ",
        .Cameo_hw_if_shutdown = Cameo_Hw_DGS1210_28_if_shutdown,
        .Cameo_hw_board_init = Cameo_Hw_DGS1210_28_board_init
	},
	{
        .pBoard_id_with_Model_Name_Type = "TPE-2840WS-V2",
        .pModel_Name = "TPE-2840WS",
        .pModel_Header_Name = "TPE-2840WS",
        .pHW_Version = "V2.0R",
        .pModel_Show_Name = "TPE-2840WS/V2.0R",
        .pModel_Name_prompt = "TPE-2840WS> ",
        .Cameo_hw_if_shutdown = Cameo_Hw_DGS1210_28P_if_shutdown,
        .Cameo_hw_board_init = Cameo_Hw_DGS1210_28P_board_init
	},
	{
        .pBoard_id_with_Model_Name_Type = "TPE-5028WS-V1",
        .pModel_Name = "TPE-5028WS",
        .pModel_Header_Name = "TPE-5028WS",
        .pHW_Version = "V1.0R",
        .pModel_Show_Name = "TPE-5028WS/V1.0R",
        .pModel_Name_prompt = "TPE-5028WS> ",
        .Cameo_hw_if_shutdown = Cameo_Hw_DGS1210_28MP_if_shutdown,
        .Cameo_hw_board_init = Cameo_Hw_DGS1210_28MP_board_init
	}
#elif defined(CONFIG_RTL8390)	
	{
        .pBoard_id_with_Model_Name_Type = "TEG-524WS-V1",
        .pModel_Name = "TEG-524WS",
        .pModel_Header_Name = "TEG-524WS",
        .pHW_Version = "V1.0R",
        .pModel_Show_Name = "TEG-524WS/V1.0R",
        .pModel_Name_prompt = "TEG-524WS> ",
        .Cameo_hw_if_shutdown = Cameo_Hw_DGS1210_52_if_shutdown,
        .Cameo_hw_board_init = Cameo_Hw_DGS1210_52_board_init
	},
	{
        .pBoard_id_with_Model_Name_Type = "TPE-5240WS-V1",
        .pModel_Name = "TPE-5240WS",
        .pModel_Header_Name = "TPE-5240WS",
        .pHW_Version = "V1.0R",
        .pModel_Show_Name = "TPE-5240WS/V1.0R",
        .pModel_Name_prompt = "TPE-5240WS> ",
        .Cameo_hw_if_shutdown = Cameo_Hw_DGS1210_52MP_if_shutdown,
        .Cameo_hw_board_init = Cameo_Hw_DGS1210_52MP_board_init
	},
	{
        .pBoard_id_with_Model_Name_Type = "TPE-5048WS-V1",
        .pModel_Name = "TPE-5048WS",
        .pModel_Header_Name = "TPE-5048WS",
        .pHW_Version = "V1.0R",
        .pModel_Show_Name = "TPE-5048WS/V1.0R",
        .pModel_Name_prompt = "TPE-5048WS> ",
        .Cameo_hw_if_shutdown = Cameo_Hw_DGS1210_52MP_if_shutdown,
        .Cameo_hw_board_init = Cameo_Hw_DGS1210_52MP_board_init
	}
#else
#error "#Error!! Please complete the implement for new solution!"
#endif /* #if defined(CONFIG_RTL8380) */
};

#endif /*end of CAMEO_CPU_DRV_DLINK_SMART_F1_LIBRARY_C*/
